// String Encryption PoC by Tomislav Zubcic
// chaplja.blogspot.com | chaplja@gmail.com

#define _CRT_SECURE_NO_WARNINGS

// standard C headers
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cstdint>

// local headers
#include "se_shared.h"

uint32_t rand_range(uint32_t mn, uint32_t mx)
{
	double scaled = rand() / (RAND_MAX + 1.0);
    return (unsigned) ((mx - mn + 1) * scaled + mn);
}

void *memmem(void *data, unsigned data_len, void *search, unsigned search_len)
{
	uint8_t		*p, *s, *last;

	p = (uint8_t *) data;
	s = (uint8_t *) search;
	last = p + data_len - search_len;

	if (data_len < search_len) {
		return NULL;
	}

	while (p < last) {
		if (*p == *s) {
			if (!memcmp(p, s, search_len)) {
				return p;
			}
		}

		p++;
	}

	return NULL;
}

int main(int argc, char *argv[])
{
	FILE		*fi, *fo;
	unsigned	in_len;
	void		*in_data;
	unsigned	cnt;
	se_string_t	*ss;
	char		*str;

	if (argc != 3) {
		printf("Usage: %s <input> <output>\n", argv[0]);
	}

	if (!(fi = fopen(argv[1], "rb"))) {
		printf("Can't open %s for reading\n", argv[1]);
		exit(1);
	}

	fseek(fi, 0, SEEK_END);
	in_len = ftell(fi);
	fseek(fi, 0, SEEK_SET);

	if (!(in_data = malloc(in_len))) {
		printf("Can't allocate %u bytes", in_len);
		exit(1);
	}

	if (fread(in_data, in_len, 1, fi) != 1) {
		printf("Can't read from input file\n");
		exit(1);
	}

	cnt = 0;

	while (ss = (se_string_t *) memmem(in_data, in_len, SE_PFX, sizeof(SE_PFX) - 1)) {
		str = ((char *) ss) + sizeof(se_string_t);

		for (unsigned i = 0; i < sizeof(ss->key); i++) {
			ss->key[i] = rand_range(0, 0xFF);
		}

		for (unsigned i = 0; i < sizeof(ss->header); i++) {
			ss->header[i] = rand_range(0, 0xFF);
		}

		ss->length = strlen(str);

		for (unsigned i = 0; i < ss->length; i++) {
			str[i] ^= ss->key[i % sizeof(ss->key)];
		}

		ss->is_encrypted = 1;

		cnt++;
	}

	if (!(fo = fopen(argv[2], "wb"))) {
		printf("Can't open %s for writing\n", argv[2]);
		exit(1);
	}

	if (fwrite(in_data, in_len, 1, fo) != 1) {
		printf("Writing to output file failed\n");
		exit(1);
	}

	fclose(fi);
	fclose(fo);

	printf("Encrypted %u strings\n", cnt);

	return 0;
}
